using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using Infragistics.Win;
using Infragistics.Shared;
using Infragistics.Win.UltraWinTree;
using Infragistics.Win.UltraWinToolbars;
using Infragistics.Win.Misc;
using Infragistics.Win.CalcEngine;
using System.Diagnostics;
using Microsoft.Win32;
using Infragistics.Win.UltraMessageBox;

namespace Infragistics.Win.UltraWinCalcManager.FormulaBuilder
{
	/// <summary>
	/// Summary description for FormulaBuilderDialog.
	/// </summary>
	public class FormulaBuilderDialog : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Panel panel1;
		private Infragistics.Win.UltraWinTabControl.UltraTabControl ultraTabControl1;
		private Infragistics.Win.UltraWinTabControl.UltraTabSharedControlsPage ultraTabSharedControlsPage1;
		private Infragistics.Win.UltraWinTabControl.UltraTabPageControl ultraTabPageControl1;
		private Infragistics.Win.UltraWinTabControl.UltraTabPageControl ultraTabPageControl2;
		private Infragistics.Win.UltraWinTree.UltraTree operandsTree;
		private Infragistics.Win.UltraWinTree.UltraTree functionsTree;
		private System.Windows.Forms.Panel panel2;
		private System.Windows.Forms.Label FunctionNameLabel;
		private System.Windows.Forms.Label FunctionDescriptionLabel;
		private System.Windows.Forms.Panel panel3;
		private System.Windows.Forms.Panel panel4;
		private Infragistics.Win.Misc.UltraButton OperatorButtonExponent;
		private Infragistics.Win.Misc.UltraButton OperatorButtonCloseParen;
		private Infragistics.Win.Misc.UltraButton OperatorButtonOpenParen;
		private Infragistics.Win.Misc.UltraButton OperatorButtonNotEqual;
		private Infragistics.Win.Misc.UltraButton OperatorButtonLessThan;
		private Infragistics.Win.Misc.UltraButton OperatorButtonGreaterThan;
		private Infragistics.Win.Misc.UltraButton OperatorButtonEquals;
		private Infragistics.Win.Misc.UltraButton OperatorButtonConcatenate;
		private Infragistics.Win.Misc.UltraButton OperatorButtonMultiply;
		private Infragistics.Win.Misc.UltraButton OperatorButtonDivide;
		private Infragistics.Win.Misc.UltraButton OperatorButtonSubtract;
		private Infragistics.Win.Misc.UltraButton OperatorButtonAdd;
		private System.Windows.Forms.RichTextBox formulaRichTextBox;
		private Infragistics.Win.Misc.UltraButton UndoButton;
		private Infragistics.Win.Misc.UltraButton RedoButton;
		private System.Windows.Forms.Panel panel5;
		private Infragistics.Win.Misc.UltraButton OKButton;
		private System.Windows.Forms.Panel panel6;
		private System.Windows.Forms.TextBox formulaStatusTextBox;
		private Infragistics.Win.UltraWinToolbars.UltraToolbarsManager ultraToolbarsManager1;
		private Infragistics.Win.UltraWinToolbars.UltraToolbarsDockArea _FormulaBuilderDialog_Toolbars_Dock_Area_Left;
		private Infragistics.Win.UltraWinToolbars.UltraToolbarsDockArea _FormulaBuilderDialog_Toolbars_Dock_Area_Right;
		private Infragistics.Win.UltraWinToolbars.UltraToolbarsDockArea _FormulaBuilderDialog_Toolbars_Dock_Area_Top;
		private Infragistics.Win.UltraWinToolbars.UltraToolbarsDockArea _FormulaBuilderDialog_Toolbars_Dock_Area_Bottom;
		private System.Windows.Forms.ToolTip toolTip1;
		private Infragistics.Win.Misc.UltraButton OperatorButtonPercent;
		private System.Windows.Forms.ImageList OperandsImageList;
		private System.Windows.Forms.ImageList FunctionsImageList;
		private Infragistics.Win.UltraWinStatusBar.UltraStatusBar ultraStatusBar1;
		private Infragistics.Win.Misc.UltraButton ClearButton;
		private System.Windows.Forms.Splitter splitterFunctions;
		private System.Windows.Forms.Splitter splitterMain;
		private System.Windows.Forms.Panel panel7;
		private Infragistics.Win.Misc.UltraButton CancelBtn;
		private System.ComponentModel.IContainer components = null;

		static FormulaBuilderDialog()
		{
			Infragistics.Win.Utilities.ForceNativeMessageFilter();
		}

		//MRS 1/21/05 - Added an overload to control whether or not help links display. 
		/// <summary>
		/// Constructor
		/// </summary>
        /// <param name="formulaProvider">An <see cref="IFormulaProvider"/> which provides formula information to the dialog.</param>
		public FormulaBuilderDialog(IFormulaProvider formulaProvider) : this(formulaProvider, false) {}

        // MRS 11/6/2009 - TFS24422
        // Overload for backward compatibility
		//MRS 1/10/05
		//public FormulaBuilderDialog(FormulaUITypeEditor formulaUITypeEditor)
		/// <summary>
		/// Constructor
		/// </summary>
        /// <param name="formulaProvider">An <see cref="IFormulaProvider"/> which provides formula information to the dialog.</param>
        /// <param name="showHelpLinks">Determines whether the help links are displayed on the dialog. These links point to URL's that reference the Infragistics help files. Turn off the links if the help will not be available to the user.</param>
		//MRS 1/21/05
		//public FormulaBuilderDialog(IFormulaProvider formulaProvider)
		public FormulaBuilderDialog(IFormulaProvider formulaProvider, bool showHelpLinks) : 
            this (formulaProvider, showHelpLinks, null)
		{
		}

        //MRS 1/10/05
        //public FormulaBuilderDialog(FormulaUITypeEditor formulaUITypeEditor)
        /// <summary>
        /// Constructor
        /// </summary>
        /// <param name="formulaProvider">An <see cref="IFormulaProvider"/> which provides formula information to the dialog.</param>
        /// <param name="showHelpLinks">Determines whether the help links are displayed on the dialog. These links point to URL's that reference the Infragistics help files. Turn off the links if the help will not be available to the user.</param>
        /// <param name="compileReference">IUltraCalcReference used strictly for compiling the formula. When null, then IFormulaProvider.Reference is used.</param>
        //MRS 1/21/05
        //public FormulaBuilderDialog(IFormulaProvider formulaProvider)
        // MRS 11/6/2009 - TFS24422
        //public FormulaBuilderDialog(IFormulaProvider formulaProvider, bool showHelpLinks)
        public FormulaBuilderDialog(IFormulaProvider formulaProvider, bool showHelpLinks, IUltraCalcReference compileReference)
        {
            //MRS 1/10/05
            //			if ( formulaUITypeEditor == null )
            //				throw new ArgumentNullException(Shared.SR.GetString("LE_Exception_0"));
            if (formulaProvider == null)
                throw new ArgumentNullException(Shared.SR.GetString("LE_Exception_0"));

            //
            // Required for Windows Form Designer support
            //
            InitializeComponent();

            //MRS 1/21/05
            this.showHelpLinks = showHelpLinks;

            //MRS 1/10/05
            // The only thing we really need to store is the FormulaProvider. We do 
            // not need the UITypeEditor. 
            //this.formulaUITypeEditor = formulaUITypeEditor;
            //this.formulaProvider = formulaUITypeEditor.formulaProvider;						
            this.formulaProvider = formulaProvider;
            this.designInfo = this.formulaProvider.CalcManager as IFormulaBuilderInfo;

            // MRS 11/6/2009 - TFS24422
            this.compileReference = compileReference == null ? this.formulaProvider.Reference : compileReference;
        }

		/// <summary>
        /// Disposes of the resources (other than memory) used by the System.Windows.Forms.Form.
		/// </summary>
        /// <param name="disposing">true to release both managed and unmanaged resources; false to release only unmanaged resources.</param>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.components = new System.ComponentModel.Container();
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(FormulaBuilderDialog));
            Infragistics.Win.UltraWinTabControl.UltraTab ultraTab1 = new Infragistics.Win.UltraWinTabControl.UltraTab();
            Infragistics.Win.Appearance appearance1 = new Infragistics.Win.Appearance();
            Infragistics.Win.UltraWinTabControl.UltraTab ultraTab2 = new Infragistics.Win.UltraWinTabControl.UltraTab();
            Infragistics.Win.Appearance appearance2 = new Infragistics.Win.Appearance();
            Infragistics.Win.UltraWinToolbars.PopupMenuTool popupMenuTool1 = new Infragistics.Win.UltraWinToolbars.PopupMenuTool("RichTextBoxMenu");
            Infragistics.Win.UltraWinToolbars.ButtonTool buttonTool1 = new Infragistics.Win.UltraWinToolbars.ButtonTool("Cut");
            Infragistics.Win.UltraWinToolbars.ButtonTool buttonTool2 = new Infragistics.Win.UltraWinToolbars.ButtonTool("Copy");
            Infragistics.Win.UltraWinToolbars.ButtonTool buttonTool3 = new Infragistics.Win.UltraWinToolbars.ButtonTool("Paste");
            Infragistics.Win.UltraWinToolbars.ButtonTool buttonTool4 = new Infragistics.Win.UltraWinToolbars.ButtonTool("Undo");
            Infragistics.Win.UltraWinToolbars.ButtonTool buttonTool5 = new Infragistics.Win.UltraWinToolbars.ButtonTool("Redo");
            Infragistics.Win.UltraWinToolbars.PopupMenuTool popupMenuTool2 = new Infragistics.Win.UltraWinToolbars.PopupMenuTool("Insert Operand");
            Infragistics.Win.UltraWinToolbars.PopupMenuTool popupMenuTool3 = new Infragistics.Win.UltraWinToolbars.PopupMenuTool("Insert Function");
            Infragistics.Win.UltraWinToolbars.ButtonTool buttonTool6 = new Infragistics.Win.UltraWinToolbars.ButtonTool("Cut");
            Infragistics.Win.Appearance appearance3 = new Infragistics.Win.Appearance();
            Infragistics.Win.UltraWinToolbars.ButtonTool buttonTool7 = new Infragistics.Win.UltraWinToolbars.ButtonTool("Copy");
            Infragistics.Win.Appearance appearance4 = new Infragistics.Win.Appearance();
            Infragistics.Win.UltraWinToolbars.ButtonTool buttonTool8 = new Infragistics.Win.UltraWinToolbars.ButtonTool("Paste");
            Infragistics.Win.Appearance appearance5 = new Infragistics.Win.Appearance();
            Infragistics.Win.UltraWinToolbars.PopupMenuTool popupMenuTool4 = new Infragistics.Win.UltraWinToolbars.PopupMenuTool("Insert Operand");
            Infragistics.Win.UltraWinToolbars.PopupMenuTool popupMenuTool5 = new Infragistics.Win.UltraWinToolbars.PopupMenuTool("Insert Function");
            Infragistics.Win.UltraWinToolbars.ButtonTool buttonTool9 = new Infragistics.Win.UltraWinToolbars.ButtonTool("Undo");
            Infragistics.Win.Appearance appearance6 = new Infragistics.Win.Appearance();
            Infragistics.Win.UltraWinToolbars.ButtonTool buttonTool10 = new Infragistics.Win.UltraWinToolbars.ButtonTool("Redo");
            Infragistics.Win.Appearance appearance7 = new Infragistics.Win.Appearance();
            Infragistics.Win.UltraWinStatusBar.UltraStatusPanel ultraStatusPanel1 = new Infragistics.Win.UltraWinStatusBar.UltraStatusPanel();
            Infragistics.Win.UltraWinStatusBar.UltraStatusPanel ultraStatusPanel2 = new Infragistics.Win.UltraWinStatusBar.UltraStatusPanel();
            this.ultraTabPageControl1 = new Infragistics.Win.UltraWinTabControl.UltraTabPageControl();
            this.operandsTree = new Infragistics.Win.UltraWinTree.UltraTree();
            this.OperandsImageList = new System.Windows.Forms.ImageList(this.components);
            this.ultraTabPageControl2 = new Infragistics.Win.UltraWinTabControl.UltraTabPageControl();
            this.functionsTree = new Infragistics.Win.UltraWinTree.UltraTree();
            this.FunctionsImageList = new System.Windows.Forms.ImageList(this.components);
            this.splitterFunctions = new System.Windows.Forms.Splitter();
            this.panel2 = new System.Windows.Forms.Panel();
            this.FunctionDescriptionLabel = new System.Windows.Forms.Label();
            this.FunctionNameLabel = new System.Windows.Forms.Label();
            this.formulaRichTextBox = new System.Windows.Forms.RichTextBox();
            this.panel1 = new System.Windows.Forms.Panel();
            this.panel3 = new System.Windows.Forms.Panel();
            this.panel4 = new System.Windows.Forms.Panel();
            this.panel7 = new System.Windows.Forms.Panel();
            this.OperatorButtonEquals = new Infragistics.Win.Misc.UltraButton();
            this.RedoButton = new Infragistics.Win.Misc.UltraButton();
            this.UndoButton = new Infragistics.Win.Misc.UltraButton();
            this.OperatorButtonExponent = new Infragistics.Win.Misc.UltraButton();
            this.OperatorButtonMultiply = new Infragistics.Win.Misc.UltraButton();
            this.OperatorButtonOpenParen = new Infragistics.Win.Misc.UltraButton();
            this.OperatorButtonPercent = new Infragistics.Win.Misc.UltraButton();
            this.OperatorButtonSubtract = new Infragistics.Win.Misc.UltraButton();
            this.OperatorButtonNotEqual = new Infragistics.Win.Misc.UltraButton();
            this.ClearButton = new Infragistics.Win.Misc.UltraButton();
            this.OperatorButtonConcatenate = new Infragistics.Win.Misc.UltraButton();
            this.OperatorButtonGreaterThan = new Infragistics.Win.Misc.UltraButton();
            this.OperatorButtonCloseParen = new Infragistics.Win.Misc.UltraButton();
            this.OperatorButtonAdd = new Infragistics.Win.Misc.UltraButton();
            this.OperatorButtonLessThan = new Infragistics.Win.Misc.UltraButton();
            this.OperatorButtonDivide = new Infragistics.Win.Misc.UltraButton();
            this.panel6 = new System.Windows.Forms.Panel();
            this.formulaStatusTextBox = new System.Windows.Forms.TextBox();
            this.panel5 = new System.Windows.Forms.Panel();
            this.OKButton = new Infragistics.Win.Misc.UltraButton();
            this.CancelBtn = new Infragistics.Win.Misc.UltraButton();
            this.splitterMain = new System.Windows.Forms.Splitter();
            this.ultraTabControl1 = new Infragistics.Win.UltraWinTabControl.UltraTabControl();
            this.ultraTabSharedControlsPage1 = new Infragistics.Win.UltraWinTabControl.UltraTabSharedControlsPage();
            this.ultraToolbarsManager1 = new Infragistics.Win.UltraWinToolbars.UltraToolbarsManager(this.components);
            this._FormulaBuilderDialog_Toolbars_Dock_Area_Left = new Infragistics.Win.UltraWinToolbars.UltraToolbarsDockArea();
            this._FormulaBuilderDialog_Toolbars_Dock_Area_Right = new Infragistics.Win.UltraWinToolbars.UltraToolbarsDockArea();
            this._FormulaBuilderDialog_Toolbars_Dock_Area_Top = new Infragistics.Win.UltraWinToolbars.UltraToolbarsDockArea();
            this._FormulaBuilderDialog_Toolbars_Dock_Area_Bottom = new Infragistics.Win.UltraWinToolbars.UltraToolbarsDockArea();
            this.toolTip1 = new System.Windows.Forms.ToolTip(this.components);
            this.ultraStatusBar1 = new Infragistics.Win.UltraWinStatusBar.UltraStatusBar();
            this.ultraTabPageControl1.SuspendLayout();
            ((System.ComponentModel.ISupportInitialize)(this.operandsTree)).BeginInit();
            this.ultraTabPageControl2.SuspendLayout();
            ((System.ComponentModel.ISupportInitialize)(this.functionsTree)).BeginInit();
            this.panel2.SuspendLayout();
            this.panel1.SuspendLayout();
            this.panel3.SuspendLayout();
            this.panel4.SuspendLayout();
            this.panel7.SuspendLayout();
            this.panel6.SuspendLayout();
            this.panel5.SuspendLayout();
            ((System.ComponentModel.ISupportInitialize)(this.ultraTabControl1)).BeginInit();
            ((System.ComponentModel.ISupportInitialize)(this.ultraToolbarsManager1)).BeginInit();
            ((System.ComponentModel.ISupportInitialize)(this.ultraStatusBar1)).BeginInit();
            this.SuspendLayout();
            // 
            // ultraTabPageControl1
            // 
            this.ultraTabPageControl1.Controls.Add(this.operandsTree);
            this.ultraTabPageControl1.Location = new System.Drawing.Point(1, 23);
            this.ultraTabPageControl1.Name = "ultraTabPageControl1";
            this.ultraTabPageControl1.Size = new System.Drawing.Size(180, 245);
            // 
            // operandsTree
            // 
            this.operandsTree.BorderStyle = Infragistics.Win.UIElementBorderStyle.None;
            this.operandsTree.Dock = System.Windows.Forms.DockStyle.Fill;
            this.operandsTree.ImageList = this.OperandsImageList;
            this.operandsTree.Location = new System.Drawing.Point(0, 0);
            this.operandsTree.Name = "operandsTree";
            this.operandsTree.Size = new System.Drawing.Size(180, 245);
            this.operandsTree.TabIndex = 0;
            this.operandsTree.DoubleClick += new System.EventHandler(this.OperandsTree_DoubleClick);
            this.operandsTree.KeyDown += new System.Windows.Forms.KeyEventHandler(this.operandsTree_KeyDown);
            // 
            // OperandsImageList
            // 
            this.OperandsImageList.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("OperandsImageList.ImageStream")));
            this.OperandsImageList.TransparentColor = System.Drawing.Color.White;
            this.OperandsImageList.Images.SetKeyName(0, "");
            this.OperandsImageList.Images.SetKeyName(1, "");
            this.OperandsImageList.Images.SetKeyName(2, "");
            this.OperandsImageList.Images.SetKeyName(3, "");
            this.OperandsImageList.Images.SetKeyName(4, "");
            this.OperandsImageList.Images.SetKeyName(5, "");
            // 
            // ultraTabPageControl2
            // 
            this.ultraTabPageControl2.Controls.Add(this.functionsTree);
            this.ultraTabPageControl2.Controls.Add(this.splitterFunctions);
            this.ultraTabPageControl2.Controls.Add(this.panel2);
            this.ultraTabPageControl2.Location = new System.Drawing.Point(-10000, -10000);
            this.ultraTabPageControl2.Name = "ultraTabPageControl2";
            this.ultraTabPageControl2.Size = new System.Drawing.Size(180, 245);
            // 
            // functionsTree
            // 
            this.functionsTree.BorderStyle = Infragistics.Win.UIElementBorderStyle.None;
            this.functionsTree.Dock = System.Windows.Forms.DockStyle.Fill;
            this.functionsTree.ImageList = this.FunctionsImageList;
            this.functionsTree.Location = new System.Drawing.Point(0, 0);
            this.functionsTree.Name = "functionsTree";
            this.functionsTree.Size = new System.Drawing.Size(180, 170);
            this.functionsTree.TabIndex = 1;
            this.functionsTree.AfterSelect += new Infragistics.Win.UltraWinTree.AfterNodeSelectEventHandler(this.functionsTree_AfterSelect);
            this.functionsTree.DoubleClick += new System.EventHandler(this.functionsTree_DoubleClick);
            this.functionsTree.KeyDown += new System.Windows.Forms.KeyEventHandler(this.functionsTree_KeyDown);
            // 
            // FunctionsImageList
            // 
            this.FunctionsImageList.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("FunctionsImageList.ImageStream")));
            this.FunctionsImageList.TransparentColor = System.Drawing.Color.White;
            this.FunctionsImageList.Images.SetKeyName(0, "");
            this.FunctionsImageList.Images.SetKeyName(1, "");
            this.FunctionsImageList.Images.SetKeyName(2, "");
            this.FunctionsImageList.Images.SetKeyName(3, "");
            this.FunctionsImageList.Images.SetKeyName(4, "");
            // 
            // splitterFunctions
            // 
            this.splitterFunctions.Dock = System.Windows.Forms.DockStyle.Bottom;
            this.splitterFunctions.Location = new System.Drawing.Point(0, 170);
            this.splitterFunctions.Name = "splitterFunctions";
            this.splitterFunctions.Size = new System.Drawing.Size(180, 3);
            this.splitterFunctions.TabIndex = 15;
            this.splitterFunctions.TabStop = false;
            // 
            // panel2
            // 
            this.panel2.Controls.Add(this.FunctionDescriptionLabel);
            this.panel2.Controls.Add(this.FunctionNameLabel);
            this.panel2.Dock = System.Windows.Forms.DockStyle.Bottom;
            this.panel2.Location = new System.Drawing.Point(0, 173);
            this.panel2.Name = "panel2";
            this.panel2.Size = new System.Drawing.Size(180, 72);
            this.panel2.TabIndex = 14;
            // 
            // FunctionDescriptionLabel
            // 
            this.FunctionDescriptionLabel.Dock = System.Windows.Forms.DockStyle.Fill;
            this.FunctionDescriptionLabel.Location = new System.Drawing.Point(0, 16);
            this.FunctionDescriptionLabel.Name = "FunctionDescriptionLabel";
            this.FunctionDescriptionLabel.Size = new System.Drawing.Size(180, 56);
            this.FunctionDescriptionLabel.TabIndex = 13;
            this.FunctionDescriptionLabel.Text = "Function Description";
            // 
            // FunctionNameLabel
            // 
            this.FunctionNameLabel.Dock = System.Windows.Forms.DockStyle.Top;
            this.FunctionNameLabel.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.FunctionNameLabel.Location = new System.Drawing.Point(0, 0);
            this.FunctionNameLabel.Name = "FunctionNameLabel";
            this.FunctionNameLabel.Size = new System.Drawing.Size(180, 16);
            this.FunctionNameLabel.TabIndex = 12;
            this.FunctionNameLabel.Text = "Function Name";
            // 
            // formulaRichTextBox
            // 
            this.formulaRichTextBox.AcceptsTab = true;
            this.formulaRichTextBox.AllowDrop = true;
            this.ultraToolbarsManager1.SetContextMenuUltra(this.formulaRichTextBox, "RichTextBoxMenu");
            this.formulaRichTextBox.DetectUrls = false;
            this.formulaRichTextBox.Dock = System.Windows.Forms.DockStyle.Fill;
            this.formulaRichTextBox.Font = new System.Drawing.Font("Courier New", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.formulaRichTextBox.HideSelection = false;
            this.formulaRichTextBox.Location = new System.Drawing.Point(0, 0);
            this.formulaRichTextBox.Name = "formulaRichTextBox";
            this.formulaRichTextBox.ScrollBars = System.Windows.Forms.RichTextBoxScrollBars.ForcedBoth;
            this.formulaRichTextBox.ShowSelectionMargin = true;
            this.formulaRichTextBox.Size = new System.Drawing.Size(561, 147);
            this.formulaRichTextBox.TabIndex = 10;
            this.formulaRichTextBox.Text = "product(quantity, price)";
            this.formulaRichTextBox.WordWrap = false;
            this.formulaRichTextBox.DragDrop += new System.Windows.Forms.DragEventHandler(this.formulaRichTextBox_DragDrop);
            this.formulaRichTextBox.DragEnter += new System.Windows.Forms.DragEventHandler(this.formulaRichTextBox_DragEnter);
            this.formulaRichTextBox.DragOver += new System.Windows.Forms.DragEventHandler(this.formulaRichTextBox_DragEnter);
            this.formulaRichTextBox.TextChanged += new System.EventHandler(this.formulaRichTextBox_TextChanged);
            this.formulaRichTextBox.KeyDown += new System.Windows.Forms.KeyEventHandler(this.formulaRichTextBox_KeyDown);
            // 
            // panel1
            // 
            this.panel1.Controls.Add(this.panel3);
            this.panel1.Controls.Add(this.splitterMain);
            this.panel1.Controls.Add(this.ultraTabControl1);
            this.panel1.Dock = System.Windows.Forms.DockStyle.Fill;
            this.panel1.Location = new System.Drawing.Point(0, 23);
            this.panel1.Name = "panel1";
            this.panel1.Size = new System.Drawing.Size(752, 271);
            this.panel1.TabIndex = 12;
            // 
            // panel3
            // 
            this.panel3.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
            this.panel3.Controls.Add(this.panel4);
            this.panel3.Controls.Add(this.panel6);
            this.panel3.Controls.Add(this.panel5);
            this.panel3.Dock = System.Windows.Forms.DockStyle.Fill;
            this.panel3.Location = new System.Drawing.Point(187, 0);
            this.panel3.Name = "panel3";
            this.panel3.Size = new System.Drawing.Size(565, 271);
            this.panel3.TabIndex = 13;
            // 
            // panel4
            // 
            this.panel4.Controls.Add(this.formulaRichTextBox);
            this.panel4.Controls.Add(this.panel7);
            this.panel4.Dock = System.Windows.Forms.DockStyle.Fill;
            this.panel4.Location = new System.Drawing.Point(0, 0);
            this.panel4.Name = "panel4";
            this.panel4.Size = new System.Drawing.Size(561, 171);
            this.panel4.TabIndex = 26;
            // 
            // panel7
            // 
            this.panel7.Controls.Add(this.OperatorButtonEquals);
            this.panel7.Controls.Add(this.RedoButton);
            this.panel7.Controls.Add(this.UndoButton);
            this.panel7.Controls.Add(this.OperatorButtonExponent);
            this.panel7.Controls.Add(this.OperatorButtonMultiply);
            this.panel7.Controls.Add(this.OperatorButtonOpenParen);
            this.panel7.Controls.Add(this.OperatorButtonPercent);
            this.panel7.Controls.Add(this.OperatorButtonSubtract);
            this.panel7.Controls.Add(this.OperatorButtonNotEqual);
            this.panel7.Controls.Add(this.ClearButton);
            this.panel7.Controls.Add(this.OperatorButtonConcatenate);
            this.panel7.Controls.Add(this.OperatorButtonGreaterThan);
            this.panel7.Controls.Add(this.OperatorButtonCloseParen);
            this.panel7.Controls.Add(this.OperatorButtonAdd);
            this.panel7.Controls.Add(this.OperatorButtonLessThan);
            this.panel7.Controls.Add(this.OperatorButtonDivide);
            this.panel7.Dock = System.Windows.Forms.DockStyle.Bottom;
            this.panel7.Location = new System.Drawing.Point(0, 147);
            this.panel7.Name = "panel7";
            this.panel7.Size = new System.Drawing.Size(561, 24);
            this.panel7.TabIndex = 29;
            // 
            // OperatorButtonEquals
            // 
            this.OperatorButtonEquals.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.OperatorButtonEquals.Location = new System.Drawing.Point(152, 0);
            this.OperatorButtonEquals.Name = "OperatorButtonEquals";
            this.OperatorButtonEquals.Size = new System.Drawing.Size(16, 23);
            this.OperatorButtonEquals.TabIndex = 16;
            this.OperatorButtonEquals.Tag = "=";
            this.OperatorButtonEquals.Text = "=";
            this.OperatorButtonEquals.UseMnemonic = false;
            this.OperatorButtonEquals.Click += new System.EventHandler(this.OperatorButton_Click);
            // 
            // RedoButton
            // 
            this.RedoButton.Location = new System.Drawing.Point(464, 0);
            this.RedoButton.Name = "RedoButton";
            this.RedoButton.Size = new System.Drawing.Size(88, 23);
            this.RedoButton.TabIndex = 27;
            this.RedoButton.Text = "Redo";
            this.RedoButton.Click += new System.EventHandler(this.RedoButton_Click);
            // 
            // UndoButton
            // 
            this.UndoButton.Location = new System.Drawing.Point(376, 0);
            this.UndoButton.Name = "UndoButton";
            this.UndoButton.Size = new System.Drawing.Size(88, 23);
            this.UndoButton.TabIndex = 25;
            this.UndoButton.Text = "Undo";
            this.UndoButton.Click += new System.EventHandler(this.UndoButton_Click);
            // 
            // OperatorButtonExponent
            // 
            this.OperatorButtonExponent.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.OperatorButtonExponent.Location = new System.Drawing.Point(72, 0);
            this.OperatorButtonExponent.Name = "OperatorButtonExponent";
            this.OperatorButtonExponent.Size = new System.Drawing.Size(16, 23);
            this.OperatorButtonExponent.TabIndex = 24;
            this.OperatorButtonExponent.Tag = "^";
            this.OperatorButtonExponent.Text = "^";
            this.OperatorButtonExponent.UseMnemonic = false;
            this.OperatorButtonExponent.Click += new System.EventHandler(this.OperatorButton_Click);
            // 
            // OperatorButtonMultiply
            // 
            this.OperatorButtonMultiply.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.OperatorButtonMultiply.Location = new System.Drawing.Point(48, 0);
            this.OperatorButtonMultiply.Name = "OperatorButtonMultiply";
            this.OperatorButtonMultiply.Size = new System.Drawing.Size(16, 23);
            this.OperatorButtonMultiply.TabIndex = 14;
            this.OperatorButtonMultiply.Tag = "*";
            this.OperatorButtonMultiply.Text = "*";
            this.OperatorButtonMultiply.UseMnemonic = false;
            this.OperatorButtonMultiply.Click += new System.EventHandler(this.OperatorButton_Click);
            // 
            // OperatorButtonOpenParen
            // 
            this.OperatorButtonOpenParen.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.OperatorButtonOpenParen.Location = new System.Drawing.Point(240, 0);
            this.OperatorButtonOpenParen.Name = "OperatorButtonOpenParen";
            this.OperatorButtonOpenParen.Size = new System.Drawing.Size(16, 23);
            this.OperatorButtonOpenParen.TabIndex = 20;
            this.OperatorButtonOpenParen.Tag = "(";
            this.OperatorButtonOpenParen.Text = "(";
            this.OperatorButtonOpenParen.UseMnemonic = false;
            this.OperatorButtonOpenParen.Click += new System.EventHandler(this.OperatorButton_Click);
            // 
            // OperatorButtonPercent
            // 
            this.OperatorButtonPercent.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.OperatorButtonPercent.Location = new System.Drawing.Point(88, 0);
            this.OperatorButtonPercent.Name = "OperatorButtonPercent";
            this.OperatorButtonPercent.Size = new System.Drawing.Size(24, 23);
            this.OperatorButtonPercent.TabIndex = 23;
            this.OperatorButtonPercent.Tag = "%";
            this.OperatorButtonPercent.Text = "%";
            this.OperatorButtonPercent.UseMnemonic = false;
            this.OperatorButtonPercent.Click += new System.EventHandler(this.OperatorButton_Click);
            // 
            // OperatorButtonSubtract
            // 
            this.OperatorButtonSubtract.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.OperatorButtonSubtract.Location = new System.Drawing.Point(16, 0);
            this.OperatorButtonSubtract.Name = "OperatorButtonSubtract";
            this.OperatorButtonSubtract.Size = new System.Drawing.Size(16, 23);
            this.OperatorButtonSubtract.TabIndex = 12;
            this.OperatorButtonSubtract.Tag = "-";
            this.OperatorButtonSubtract.Text = "-";
            this.OperatorButtonSubtract.UseMnemonic = false;
            this.OperatorButtonSubtract.Click += new System.EventHandler(this.OperatorButton_Click);
            // 
            // OperatorButtonNotEqual
            // 
            this.OperatorButtonNotEqual.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.OperatorButtonNotEqual.Location = new System.Drawing.Point(200, 0);
            this.OperatorButtonNotEqual.Name = "OperatorButtonNotEqual";
            this.OperatorButtonNotEqual.Size = new System.Drawing.Size(32, 23);
            this.OperatorButtonNotEqual.TabIndex = 19;
            this.OperatorButtonNotEqual.Tag = "<>";
            this.OperatorButtonNotEqual.Text = "<>";
            this.OperatorButtonNotEqual.UseMnemonic = false;
            this.OperatorButtonNotEqual.Click += new System.EventHandler(this.OperatorButton_Click);
            // 
            // ClearButton
            // 
            this.ClearButton.Location = new System.Drawing.Point(288, 0);
            this.ClearButton.Name = "ClearButton";
            this.ClearButton.Size = new System.Drawing.Size(88, 23);
            this.ClearButton.TabIndex = 28;
            this.ClearButton.Text = "Clear";
            this.ClearButton.Click += new System.EventHandler(this.ClearButton_Click);
            // 
            // OperatorButtonConcatenate
            // 
            this.OperatorButtonConcatenate.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.OperatorButtonConcatenate.Location = new System.Drawing.Point(120, 0);
            this.OperatorButtonConcatenate.Name = "OperatorButtonConcatenate";
            this.OperatorButtonConcatenate.Size = new System.Drawing.Size(24, 23);
            this.OperatorButtonConcatenate.TabIndex = 15;
            this.OperatorButtonConcatenate.Tag = "&";
            this.OperatorButtonConcatenate.Text = "&";
            this.OperatorButtonConcatenate.UseMnemonic = false;
            this.OperatorButtonConcatenate.Click += new System.EventHandler(this.OperatorButton_Click);
            // 
            // OperatorButtonGreaterThan
            // 
            this.OperatorButtonGreaterThan.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.OperatorButtonGreaterThan.Location = new System.Drawing.Point(168, 0);
            this.OperatorButtonGreaterThan.Name = "OperatorButtonGreaterThan";
            this.OperatorButtonGreaterThan.Size = new System.Drawing.Size(16, 23);
            this.OperatorButtonGreaterThan.TabIndex = 17;
            this.OperatorButtonGreaterThan.Tag = ">";
            this.OperatorButtonGreaterThan.Text = ">";
            this.OperatorButtonGreaterThan.UseMnemonic = false;
            this.OperatorButtonGreaterThan.Click += new System.EventHandler(this.OperatorButton_Click);
            // 
            // OperatorButtonCloseParen
            // 
            this.OperatorButtonCloseParen.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.OperatorButtonCloseParen.Location = new System.Drawing.Point(256, 0);
            this.OperatorButtonCloseParen.Name = "OperatorButtonCloseParen";
            this.OperatorButtonCloseParen.Size = new System.Drawing.Size(16, 23);
            this.OperatorButtonCloseParen.TabIndex = 21;
            this.OperatorButtonCloseParen.Tag = ")";
            this.OperatorButtonCloseParen.Text = ")";
            this.OperatorButtonCloseParen.UseMnemonic = false;
            this.OperatorButtonCloseParen.Click += new System.EventHandler(this.OperatorButton_Click);
            // 
            // OperatorButtonAdd
            // 
            this.OperatorButtonAdd.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.OperatorButtonAdd.Location = new System.Drawing.Point(0, 0);
            this.OperatorButtonAdd.Name = "OperatorButtonAdd";
            this.OperatorButtonAdd.Size = new System.Drawing.Size(16, 23);
            this.OperatorButtonAdd.TabIndex = 11;
            this.OperatorButtonAdd.Tag = "+";
            this.OperatorButtonAdd.Text = "+";
            this.OperatorButtonAdd.UseMnemonic = false;
            this.OperatorButtonAdd.Click += new System.EventHandler(this.OperatorButton_Click);
            // 
            // OperatorButtonLessThan
            // 
            this.OperatorButtonLessThan.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.OperatorButtonLessThan.Location = new System.Drawing.Point(184, 0);
            this.OperatorButtonLessThan.Name = "OperatorButtonLessThan";
            this.OperatorButtonLessThan.Size = new System.Drawing.Size(16, 23);
            this.OperatorButtonLessThan.TabIndex = 18;
            this.OperatorButtonLessThan.Tag = "<";
            this.OperatorButtonLessThan.Text = "<";
            this.OperatorButtonLessThan.UseMnemonic = false;
            this.OperatorButtonLessThan.Click += new System.EventHandler(this.OperatorButton_Click);
            // 
            // OperatorButtonDivide
            // 
            this.OperatorButtonDivide.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.OperatorButtonDivide.Location = new System.Drawing.Point(32, 0);
            this.OperatorButtonDivide.Name = "OperatorButtonDivide";
            this.OperatorButtonDivide.Size = new System.Drawing.Size(16, 23);
            this.OperatorButtonDivide.TabIndex = 13;
            this.OperatorButtonDivide.Tag = "/";
            this.OperatorButtonDivide.Text = "/";
            this.OperatorButtonDivide.UseMnemonic = false;
            this.OperatorButtonDivide.Click += new System.EventHandler(this.OperatorButton_Click);
            // 
            // panel6
            // 
            this.panel6.Controls.Add(this.formulaStatusTextBox);
            this.panel6.Dock = System.Windows.Forms.DockStyle.Bottom;
            this.panel6.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.panel6.Location = new System.Drawing.Point(0, 171);
            this.panel6.Name = "panel6";
            this.panel6.Size = new System.Drawing.Size(561, 72);
            this.panel6.TabIndex = 28;
            // 
            // formulaStatusTextBox
            // 
            this.formulaStatusTextBox.BackColor = System.Drawing.SystemColors.Window;
            this.formulaStatusTextBox.Dock = System.Windows.Forms.DockStyle.Fill;
            this.formulaStatusTextBox.Location = new System.Drawing.Point(0, 0);
            this.formulaStatusTextBox.Multiline = true;
            this.formulaStatusTextBox.Name = "formulaStatusTextBox";
            this.formulaStatusTextBox.ReadOnly = true;
            this.formulaStatusTextBox.Size = new System.Drawing.Size(561, 72);
            this.formulaStatusTextBox.TabIndex = 0;
            // 
            // panel5
            // 
            this.panel5.Controls.Add(this.OKButton);
            this.panel5.Controls.Add(this.CancelBtn);
            this.panel5.Dock = System.Windows.Forms.DockStyle.Bottom;
            this.panel5.Location = new System.Drawing.Point(0, 243);
            this.panel5.Name = "panel5";
            this.panel5.Size = new System.Drawing.Size(561, 24);
            this.panel5.TabIndex = 27;
            // 
            // OKButton
            // 
            this.OKButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
            this.OKButton.Location = new System.Drawing.Point(344, 0);
            this.OKButton.Name = "OKButton";
            this.OKButton.Size = new System.Drawing.Size(104, 23);
            this.OKButton.TabIndex = 26;
            this.OKButton.Text = "OK";
            this.OKButton.Click += new System.EventHandler(this.OKButton_Click);
            // 
            // CancelBtn
            // 
            this.CancelBtn.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
            this.CancelBtn.Location = new System.Drawing.Point(456, 0);
            this.CancelBtn.Name = "CancelBtn";
            this.CancelBtn.Size = new System.Drawing.Size(104, 23);
            this.CancelBtn.TabIndex = 25;
            this.CancelBtn.Text = "Cancel";
            this.CancelBtn.Click += new System.EventHandler(this.CancelButton_Click);
            // 
            // splitterMain
            // 
            this.splitterMain.Location = new System.Drawing.Point(184, 0);
            this.splitterMain.Name = "splitterMain";
            this.splitterMain.Size = new System.Drawing.Size(3, 271);
            this.splitterMain.TabIndex = 13;
            this.splitterMain.TabStop = false;
            // 
            // ultraTabControl1
            // 
            this.ultraTabControl1.Controls.Add(this.ultraTabSharedControlsPage1);
            this.ultraTabControl1.Controls.Add(this.ultraTabPageControl1);
            this.ultraTabControl1.Controls.Add(this.ultraTabPageControl2);
            this.ultraTabControl1.Dock = System.Windows.Forms.DockStyle.Left;
            this.ultraTabControl1.ImageTransparentColor = System.Drawing.Color.Magenta;
            this.ultraTabControl1.Location = new System.Drawing.Point(0, 0);
            this.ultraTabControl1.Name = "ultraTabControl1";
            this.ultraTabControl1.SharedControlsPage = this.ultraTabSharedControlsPage1;
            this.ultraTabControl1.Size = new System.Drawing.Size(184, 271);
            this.ultraTabControl1.TabIndex = 12;
            appearance1.Image = ((object)(resources.GetObject("appearance1.Image")));
            ultraTab1.Appearance = appearance1;
            ultraTab1.Key = "OperandsTab";
            ultraTab1.TabPage = this.ultraTabPageControl1;
            ultraTab1.Text = "Operands";
            appearance2.Image = ((object)(resources.GetObject("appearance2.Image")));
            ultraTab2.Appearance = appearance2;
            ultraTab2.Key = "FunctionsTab";
            ultraTab2.TabPage = this.ultraTabPageControl2;
            ultraTab2.Text = "Functions";
            this.ultraTabControl1.Tabs.AddRange(new Infragistics.Win.UltraWinTabControl.UltraTab[] {
            ultraTab1,
            ultraTab2});
            // 
            // ultraTabSharedControlsPage1
            // 
            this.ultraTabSharedControlsPage1.Location = new System.Drawing.Point(-10000, -10000);
            this.ultraTabSharedControlsPage1.Name = "ultraTabSharedControlsPage1";
            this.ultraTabSharedControlsPage1.Size = new System.Drawing.Size(180, 245);
            // 
            // ultraToolbarsManager1
            // 
            this.ultraToolbarsManager1.DesignerFlags = 0;
            this.ultraToolbarsManager1.DockWithinContainer = this;
            this.ultraToolbarsManager1.DockWithinContainerBaseType = typeof(System.Windows.Forms.Form);
            this.ultraToolbarsManager1.ImageTransparentColor = System.Drawing.Color.Magenta;
            this.ultraToolbarsManager1.SettingsKey = "";
            this.ultraToolbarsManager1.ShowFullMenusDelay = 500;
            popupMenuTool1.SharedPropsInternal.Caption = "RichTextBoxMenu";
            buttonTool4.InstanceProps.IsFirstInGroup = true;
            popupMenuTool2.InstanceProps.IsFirstInGroup = true;
            popupMenuTool1.Tools.AddRange(new Infragistics.Win.UltraWinToolbars.ToolBase[] {
            buttonTool1,
            buttonTool2,
            buttonTool3,
            buttonTool4,
            buttonTool5,
            popupMenuTool2,
            popupMenuTool3});
            appearance3.Image = ((object)(resources.GetObject("appearance3.Image")));
            buttonTool6.SharedPropsInternal.AppearancesSmall.Appearance = appearance3;
            buttonTool6.SharedPropsInternal.Caption = "Cu&t";
            buttonTool6.SharedPropsInternal.Shortcut = System.Windows.Forms.Shortcut.CtrlX;
            appearance4.Image = ((object)(resources.GetObject("appearance4.Image")));
            buttonTool7.SharedPropsInternal.AppearancesSmall.Appearance = appearance4;
            buttonTool7.SharedPropsInternal.Caption = "&Copy";
            buttonTool7.SharedPropsInternal.Shortcut = System.Windows.Forms.Shortcut.CtrlC;
            appearance5.Image = ((object)(resources.GetObject("appearance5.Image")));
            buttonTool8.SharedPropsInternal.AppearancesSmall.Appearance = appearance5;
            buttonTool8.SharedPropsInternal.Caption = "&Paste";
            buttonTool8.SharedPropsInternal.Shortcut = System.Windows.Forms.Shortcut.CtrlV;
            popupMenuTool4.SharedPropsInternal.Caption = "Insert Operand";
            popupMenuTool5.SharedPropsInternal.Caption = "Insert Function";
            appearance6.Image = ((object)(resources.GetObject("appearance6.Image")));
            buttonTool9.SharedPropsInternal.AppearancesSmall.Appearance = appearance6;
            buttonTool9.SharedPropsInternal.Caption = "Undo";
            buttonTool9.SharedPropsInternal.Shortcut = System.Windows.Forms.Shortcut.CtrlZ;
            appearance7.Image = ((object)(resources.GetObject("appearance7.Image")));
            buttonTool10.SharedPropsInternal.AppearancesSmall.Appearance = appearance7;
            buttonTool10.SharedPropsInternal.Caption = "Redo";
            buttonTool10.SharedPropsInternal.Shortcut = System.Windows.Forms.Shortcut.CtrlY;
            this.ultraToolbarsManager1.Tools.AddRange(new Infragistics.Win.UltraWinToolbars.ToolBase[] {
            popupMenuTool1,
            buttonTool6,
            buttonTool7,
            buttonTool8,
            popupMenuTool4,
            popupMenuTool5,
            buttonTool9,
            buttonTool10});
            this.ultraToolbarsManager1.BeforeToolDropdown += new Infragistics.Win.UltraWinToolbars.BeforeToolDropdownEventHandler(this.ultraToolbarsManager1_BeforeToolDropdown);
            this.ultraToolbarsManager1.ToolClick += new Infragistics.Win.UltraWinToolbars.ToolClickEventHandler(this.ultraToolbarsManager1_ToolClick);
            // 
            // _FormulaBuilderDialog_Toolbars_Dock_Area_Left
            // 
            this._FormulaBuilderDialog_Toolbars_Dock_Area_Left.AccessibleRole = System.Windows.Forms.AccessibleRole.Grouping;
            this._FormulaBuilderDialog_Toolbars_Dock_Area_Left.BackColor = System.Drawing.SystemColors.Control;
            this._FormulaBuilderDialog_Toolbars_Dock_Area_Left.DockedPosition = Infragistics.Win.UltraWinToolbars.DockedPosition.Left;
            this._FormulaBuilderDialog_Toolbars_Dock_Area_Left.ForeColor = System.Drawing.SystemColors.ControlText;
            this._FormulaBuilderDialog_Toolbars_Dock_Area_Left.Location = new System.Drawing.Point(0, 23);
            this._FormulaBuilderDialog_Toolbars_Dock_Area_Left.Name = "_FormulaBuilderDialog_Toolbars_Dock_Area_Left";
            this._FormulaBuilderDialog_Toolbars_Dock_Area_Left.Size = new System.Drawing.Size(0, 271);
            this._FormulaBuilderDialog_Toolbars_Dock_Area_Left.ToolbarsManager = this.ultraToolbarsManager1;
            // 
            // _FormulaBuilderDialog_Toolbars_Dock_Area_Right
            // 
            this._FormulaBuilderDialog_Toolbars_Dock_Area_Right.AccessibleRole = System.Windows.Forms.AccessibleRole.Grouping;
            this._FormulaBuilderDialog_Toolbars_Dock_Area_Right.BackColor = System.Drawing.SystemColors.Control;
            this._FormulaBuilderDialog_Toolbars_Dock_Area_Right.DockedPosition = Infragistics.Win.UltraWinToolbars.DockedPosition.Right;
            this._FormulaBuilderDialog_Toolbars_Dock_Area_Right.ForeColor = System.Drawing.SystemColors.ControlText;
            this._FormulaBuilderDialog_Toolbars_Dock_Area_Right.Location = new System.Drawing.Point(752, 23);
            this._FormulaBuilderDialog_Toolbars_Dock_Area_Right.Name = "_FormulaBuilderDialog_Toolbars_Dock_Area_Right";
            this._FormulaBuilderDialog_Toolbars_Dock_Area_Right.Size = new System.Drawing.Size(0, 271);
            this._FormulaBuilderDialog_Toolbars_Dock_Area_Right.ToolbarsManager = this.ultraToolbarsManager1;
            // 
            // _FormulaBuilderDialog_Toolbars_Dock_Area_Top
            // 
            this._FormulaBuilderDialog_Toolbars_Dock_Area_Top.AccessibleRole = System.Windows.Forms.AccessibleRole.Grouping;
            this._FormulaBuilderDialog_Toolbars_Dock_Area_Top.BackColor = System.Drawing.SystemColors.Control;
            this._FormulaBuilderDialog_Toolbars_Dock_Area_Top.DockedPosition = Infragistics.Win.UltraWinToolbars.DockedPosition.Top;
            this._FormulaBuilderDialog_Toolbars_Dock_Area_Top.ForeColor = System.Drawing.SystemColors.ControlText;
            this._FormulaBuilderDialog_Toolbars_Dock_Area_Top.Location = new System.Drawing.Point(0, 0);
            this._FormulaBuilderDialog_Toolbars_Dock_Area_Top.Name = "_FormulaBuilderDialog_Toolbars_Dock_Area_Top";
            this._FormulaBuilderDialog_Toolbars_Dock_Area_Top.Size = new System.Drawing.Size(752, 0);
            this._FormulaBuilderDialog_Toolbars_Dock_Area_Top.ToolbarsManager = this.ultraToolbarsManager1;
            // 
            // _FormulaBuilderDialog_Toolbars_Dock_Area_Bottom
            // 
            this._FormulaBuilderDialog_Toolbars_Dock_Area_Bottom.AccessibleRole = System.Windows.Forms.AccessibleRole.Grouping;
            this._FormulaBuilderDialog_Toolbars_Dock_Area_Bottom.BackColor = System.Drawing.SystemColors.Control;
            this._FormulaBuilderDialog_Toolbars_Dock_Area_Bottom.DockedPosition = Infragistics.Win.UltraWinToolbars.DockedPosition.Bottom;
            this._FormulaBuilderDialog_Toolbars_Dock_Area_Bottom.ForeColor = System.Drawing.SystemColors.ControlText;
            this._FormulaBuilderDialog_Toolbars_Dock_Area_Bottom.Location = new System.Drawing.Point(0, 294);
            this._FormulaBuilderDialog_Toolbars_Dock_Area_Bottom.Name = "_FormulaBuilderDialog_Toolbars_Dock_Area_Bottom";
            this._FormulaBuilderDialog_Toolbars_Dock_Area_Bottom.Size = new System.Drawing.Size(752, 0);
            this._FormulaBuilderDialog_Toolbars_Dock_Area_Bottom.ToolbarsManager = this.ultraToolbarsManager1;
            // 
            // ultraStatusBar1
            // 
            this.ultraStatusBar1.Dock = System.Windows.Forms.DockStyle.Top;
            this.ultraStatusBar1.Location = new System.Drawing.Point(0, 0);
            this.ultraStatusBar1.Name = "ultraStatusBar1";
            ultraStatusPanel1.Key = "FormulaTarget";
            ultraStatusPanel1.SizingMode = Infragistics.Win.UltraWinStatusBar.PanelSizingMode.Spring;
            ultraStatusPanel2.Control = this.formulaRichTextBox;
            ultraStatusPanel2.Key = "RichTextBoxPosition";
            ultraStatusPanel2.Style = Infragistics.Win.UltraWinStatusBar.PanelStyle.CharacterPosition;
            this.ultraStatusBar1.Panels.AddRange(new Infragistics.Win.UltraWinStatusBar.UltraStatusPanel[] {
            ultraStatusPanel1,
            ultraStatusPanel2});
            this.ultraStatusBar1.ResizeStyle = Infragistics.Win.UltraWinStatusBar.ResizeStyle.None;
            this.ultraStatusBar1.Size = new System.Drawing.Size(752, 23);
            this.ultraStatusBar1.SizeGripVisible = Infragistics.Win.DefaultableBoolean.False;
            this.ultraStatusBar1.TabIndex = 17;
            this.ultraStatusBar1.Text = "ultraStatusBar1";
            this.ultraStatusBar1.ViewStyle = Infragistics.Win.UltraWinStatusBar.ViewStyle.Office2003;
            this.ultraStatusBar1.WrapText = false;
            // 
            // FormulaBuilderDialog
            // 
            this.AcceptButton = this.OKButton;
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 14);
            this.ClientSize = new System.Drawing.Size(752, 294);
            this.ControlBox = false;
            this.Controls.Add(this.panel1);
            this.Controls.Add(this._FormulaBuilderDialog_Toolbars_Dock_Area_Left);
            this.Controls.Add(this._FormulaBuilderDialog_Toolbars_Dock_Area_Right);
            this.Controls.Add(this._FormulaBuilderDialog_Toolbars_Dock_Area_Bottom);
            this.Controls.Add(this.ultraStatusBar1);
            this.Controls.Add(this._FormulaBuilderDialog_Toolbars_Dock_Area_Top);
            this.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.MinimizeBox = false;
            this.Name = "FormulaBuilderDialog";
            this.StartPosition = System.Windows.Forms.FormStartPosition.CenterParent;
            this.Text = "Formula Builder";
            this.Closing += new System.ComponentModel.CancelEventHandler(this.FormulaBuilderDialog_Closing);
            this.Load += new System.EventHandler(this.FormulaBuilderDialog_Load);
            this.ultraTabPageControl1.ResumeLayout(false);
            ((System.ComponentModel.ISupportInitialize)(this.operandsTree)).EndInit();
            this.ultraTabPageControl2.ResumeLayout(false);
            ((System.ComponentModel.ISupportInitialize)(this.functionsTree)).EndInit();
            this.panel2.ResumeLayout(false);
            this.panel1.ResumeLayout(false);
            this.panel3.ResumeLayout(false);
            this.panel4.ResumeLayout(false);
            this.panel7.ResumeLayout(false);
            this.panel6.ResumeLayout(false);
            this.panel6.PerformLayout();
            this.panel5.ResumeLayout(false);
            ((System.ComponentModel.ISupportInitialize)(this.ultraTabControl1)).EndInit();
            ((System.ComponentModel.ISupportInitialize)(this.ultraToolbarsManager1)).EndInit();
            ((System.ComponentModel.ISupportInitialize)(this.ultraStatusBar1)).EndInit();
            this.ResumeLayout(false);

		}
		#endregion

		#region Private Members

		//MRS 1/10/05
		// The only thing we really need to store is the FormulaProvider. We do 
		// not need the UITypeEditor. 
		//internal FormulaUITypeEditor formulaUITypeEditor = null;
		private IFormulaBuilderInfo designInfo = null;

		internal IFormulaProvider formulaProvider = null;		
		private bool compilePending	 = false;
		private OperandTreeDragHelper operandTreeDragHelper = null;
		private FunctionTreeDragHelper functionTreeDragHelper = null;
		private bool hasSyntaxError = false;		
		private bool isDirty = false;				

		internal static readonly string	DESIGNER_REG_KEY = FormulaUITypeEditor.DESIGNER_REG_KEY + "\\FormulaBuilder";

		//MRS 1/11/05 - Added support for aliasing/cancelling references.
		internal AliasManager aliasManager = null;

		//MRS 1/21/05
		bool showHelpLinks = false;
        
        // MRS 11/6/2009 - TFS24422
        IUltraCalcReference compileReference;

		#endregion Private Members

		#region Public Properties

		#region Formula
		/// <summary>
		/// Returns the formula
		/// </summary>
		public string Formula
		{
			get 
			{				
				// Getting the Text of a RichTextBox causes the undo/redo cache to get cleared. 
				// So get the text using the NativeWindowMethods class. 
				//return NativeWindowMethods.GetText(this.formulaRichTextBox); 
				string text = NativeWindowMethods.GetText(this.formulaRichTextBox); 

				// AS 9/9/04 UWC79
				text = text.Replace("\r", "\r\n");

				// MRS 9/14/04 UWC91
				text = text.Trim();

				return text;
			}
		}
		#endregion Formula

		#region HasSyntaxError
		/// <summary>
		/// Returns whether the Formula property has any Syntax errors.
		/// </summary>
		public bool HasSyntaxError
		{
			get 
			{ 
				this.CompileFormula();
				return this.hasSyntaxError; 
			}
		}
		#endregion HasSyntaxError

		#endregion Public Properties

		#region Event Handlers

		#region FormulaBuilderDialog_Load
		private void FormulaBuilderDialog_Load(object sender, System.EventArgs e)
		{
			// Add the Reference Tree to the AliasManager so it only creates
			// the list once and can properly compare objects. 
			this.aliasManager = new AliasManager(this.designInfo.GetReferenceTree());

			this.ApplySettingsFromRegistry();

			this.InitializeUI();
		}
		#endregion FormulaBuilderDialog_Load

		#region FormulaBuilderDialog_Closing

		private void FormulaBuilderDialog_Closing(object sender, System.ComponentModel.CancelEventArgs e)
		{
			this.SaveSettingsToRegistry();

			this.StoreTreeSettings();
		}

		#endregion FormulaBuilderDialog_Closing

		#region Tree events

		#region functionsTree

		#region functionsTree_AfterSelect
		private void functionsTree_AfterSelect(object sender, Infragistics.Win.UltraWinTree.SelectEventArgs e)
		{
			UltraTree tree = sender as UltraTree;
			UltraCalcFunction function = tree.ActiveNode.Tag as UltraCalcFunction;
			if ( function == null ) 
			{
				this.FunctionNameLabel.Text = string.Empty;
				this.FunctionDescriptionLabel.Text = string.Empty;
				return;
			}

			this.FunctionNameLabel.Text = function.Name;
			this.FunctionDescriptionLabel.Text = function.Description;
		}
		#endregion functionsTree_AfterSelect

		#region functionsTree_DoubleClick

		private void functionsTree_DoubleClick(object sender, System.EventArgs e)
		{
			UltraTree tree = sender as UltraTree;
			UltraTreeNode node = tree.UIElement.LastElementEntered.GetContext(typeof(UltraTreeNode)) as UltraTreeNode;
			
			if ( node == null ) 
				return;

			UltraCalcFunction function = node.Tag as UltraCalcFunction;
			if ( function == null )
				return;

			this.InsertFunction(function);
		
		}
		#endregion functionsTree_DoubleClick

		#region functionsTree_KeyDown

		private void functionsTree_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
		{
			if ( e.KeyCode == Keys.Enter)
			{
				UltraTree tree = sender as UltraTree;
				if ( tree.SelectedNodes.Count == 0 )
					return;

				UltraTreeNode node = tree.SelectedNodes[0] as UltraTreeNode;
			
				if ( node == null ) 
					return;
			
				UltraCalcFunction function = this.GetSelectedFunction();
				if ( function == null )
					return;

				this.InsertFunction(function);
			}
		}

		#endregion functionsTree_KeyDown

		#endregion functionsTree

		#region operandsTree

		#region OperandsTree_DoubleClick
		private void OperandsTree_DoubleClick(object sender, System.EventArgs e)
		{
			UltraTree tree = sender as UltraTree;
			ReferenceTreeNode node = tree.UIElement.LastElementEntered.GetContext(typeof(UltraTreeNode)) as ReferenceTreeNode;
			
			if ( node == null ) 
				return;
			
			this.InsertReferenceNameIntoFormula(node.RelativeName);
		}
		#endregion OperandsTree_DoubleClick

		#region operandsTree_KeyDown

		private void operandsTree_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
		{
			if ( e.KeyCode == Keys.Enter )
			{
				UltraTree tree = sender as UltraTree;
				if ( tree.SelectedNodes.Count == 0 )
					return;

				ReferenceTreeNode node = tree.SelectedNodes[0] as ReferenceTreeNode;
			
				if ( node == null ) 
					return;
			
				this.InsertReferenceNameIntoFormula(node.RelativeName);
				e.Handled = true;
			}
		}

		#endregion operandsTree_KeyDown

		#endregion operandsTree

		#endregion Tree events

		#region OperatorButton Events

		private void OperatorButton_Click(object sender, System.EventArgs e)
		{
			bool addLeadingSpace = true;
			bool addTrailingSpace = true;
			
			UltraButton button = sender as UltraButton;

			string operand = button.Tag.ToString();

			// UWC36
			char lastChar = this.GetLastChar();
			if ( lastChar != char.MinValue )
			{
				if ( lastChar == '<' &&
					( operand == "=" || operand == ">" ) )
				{
					addLeadingSpace = false;
				}
				else if ( lastChar == '>' &&
					operand == "=" )
				{
					addLeadingSpace = false;
				}
				else if ( lastChar == ' ' )
					addLeadingSpace = false;
			}

			char nextChar = this.GetNextChar();
			if ( operand == "<" ||
				operand == ">" )
			{
				addTrailingSpace = false;
			}
			else if ( nextChar == ' ' )
				addTrailingSpace = false;
			
			string leadingSpace = addLeadingSpace ? " " : string.Empty;
			string trailingSpace = addTrailingSpace ? " " : string.Empty;

			this.formulaRichTextBox.SelectedText = leadingSpace + operand + trailingSpace;
			this.formulaRichTextBox.Focus();
		}

		#endregion OperatorButton Events

		#region Undo/Redo Button Events

		private void UndoButton_Click(object sender, System.EventArgs e)
		{
			this.formulaRichTextBox.Undo();
			this.VerifyButtonEnabledStates();	
		}
		private void RedoButton_Click(object sender, System.EventArgs e)
		{
			this.formulaRichTextBox.Redo();
			this.VerifyButtonEnabledStates();	
		}

		private void ClearButton_Click(object sender, System.EventArgs e)
		{
			this.formulaRichTextBox.Clear();
			this.VerifyButtonEnabledStates();	
		}

		#endregion Undo/Redo Button Events

		#region RichTextBox Events

		#region formulaRichTextBox_TextChanged
		private void formulaRichTextBox_TextChanged(object sender, System.EventArgs e)
		{
			if ( !compilePending )
			{
				compilePending = true;
				this.BeginInvoke(new MethodInvoker(this.CompileFormula));
			}

			RichTextBox richTextBox = sender as RichTextBox;
			this.UndoButton.Enabled = richTextBox.CanUndo;
			this.RedoButton.Enabled = richTextBox.CanRedo;
			isDirty = true;
		}
		#endregion formulaRichTextBox_TextChanged

		#region formulaRichTextBox_DragEnter
		private void formulaRichTextBox_DragEnter(object sender, System.Windows.Forms.DragEventArgs e)
		{
			bool isDataPresent = e.Data.GetDataPresent(DataFormats.Text);
			if ( !isDataPresent) 
			{
				e.Effect = DragDropEffects.None;
				return;
			}

			string dragString = e.Data.GetData(DataFormats.Text) as string;

			if ( this.functionTreeDragHelper.isDragging || 
				this.operandTreeDragHelper.isDragging )
			{
				e.Effect = DragDropEffects.Copy;
				return;
			}

			e.Effect = DragDropEffects.Move;
		}
		#endregion formulaRichTextBox_DragEnter

		#region formulaRichTextBox_DragDrop
		private void formulaRichTextBox_DragDrop(object sender, System.Windows.Forms.DragEventArgs e)
		{	
			e.Effect = DragDropEffects.Move;

			string dragString = e.Data.GetData(DataFormats.Text) as string;

			if ( this.functionTreeDragHelper.isDragging )
			{
				e.Effect = DragDropEffects.None;
				UltraCalcFunction function = this.GetSelectedFunction();
				if ( function == null )
					return;
								
				this.InsertFunction(function);
				
				this.functionTreeDragHelper.isDragging = false;

				return;				
			}
			else if ( this.operandTreeDragHelper.isDragging )
			{
				e.Effect = DragDropEffects.None;
				this.InsertReferenceNameIntoFormula(dragString);
				this.operandTreeDragHelper.isDragging = false;
				return;
			}
		}
		#endregion formulaRichTextBox_DragDrop

		#region formulaRichTextBox_KeyDown
		private void formulaRichTextBox_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
		{
			// Even though there's a context menu, the RichTextBox is still handling Cut, Copy, and Paste. 
			// So kill it.
			if ( e.Control )
			{
				if ( e.KeyCode == Keys.V ||
					e.KeyCode == Keys.C ||
					e.KeyCode == Keys.X)
				{
					// These will get handled by the context menu
					e.Handled = true;
					return;
				}
			}	
		
			// Handle the old-style Paste so we don't get rich formatting 
			// from other apps.  
			if ( e.Shift &&
				e.KeyCode == Keys.Insert)
			{
				this.Paste();
				e.Handled = true;
				return;
			}
			
		}
		#endregion formulaRichTextBox_KeyDown

		#endregion  RichTextBox Events

		#region Toolbar events

		private void ultraToolbarsManager1_BeforeToolDropdown(object sender, Infragistics.Win.UltraWinToolbars.BeforeToolDropdownEventArgs e)
		{			
			UltraToolbarsManager ultraToolbarsManager = sender as UltraToolbarsManager;

			switch (e.Tool.Key)
			{
				case "RichTextBoxMenu":
					ultraToolbarsManager.Tools["Undo"].SharedProps.Enabled = this.formulaRichTextBox.CanUndo;
					ultraToolbarsManager.Tools["Redo"].SharedProps.Enabled = this.formulaRichTextBox.CanRedo;
					ultraToolbarsManager.Tools["Cut"].SharedProps.Enabled = this.formulaRichTextBox.SelectedText.Length > 0;
					ultraToolbarsManager.Tools["Copy"].SharedProps.Enabled = this.formulaRichTextBox.SelectedText.Length > 0;
					break;

			}
		}

		private void ultraToolbarsManager1_ToolClick(object sender, Infragistics.Win.UltraWinToolbars.ToolClickEventArgs e)
		{
			if ( e.Tool.Key.StartsWith("Operand:") )
			{
				this.InsertReferenceNameIntoFormula( e.Tool.SharedProps.Tag.ToString() );
				return;
			}

			if ( e.Tool.Key.StartsWith("Function:") )
			{
				this.InsertFunction((UltraCalcFunction)e.Tool.SharedProps.Tag);
				return;
			}
											   
			switch (e.Tool.Key)
			{
				case "Cut":
					this.Cut();
					break;
				case "Copy":
					this.Copy();
					break;
				case "Paste":
					this.Paste();
					break;

				case "Undo":
					this.formulaRichTextBox.Undo();
					this.UndoButton.Enabled = this.formulaRichTextBox.CanUndo;
					break;

				case "Redo":
					this.formulaRichTextBox.Redo();
					this.UndoButton.Enabled = this.formulaRichTextBox.CanRedo;
					break;
			}
		}

		#endregion Toolbar Events

		#region Other Button Events

		#region OKButton_Click

		private void OKButton_Click(object sender, System.EventArgs e)
		{
			if ( this.hasSyntaxError )
			{
                // VC 02/03/2010
                // V10.1 UltraMessageBoxManager update
				//DialogResult result = MessageBox.Show(this, SR.GetString("FormulaBuilderDialog_SyntaxError_Warning"), SR.GetString("FormulaBuilderDialog_SyntaxError_Warning_Title"), MessageBoxButtons.YesNoCancel, MessageBoxIcon.Warning);
                DialogResult result = UltraMessageBoxManager.Show(this, SR.GetString("FormulaBuilderDialog_SyntaxError_Warning"), SR.GetString("FormulaBuilderDialog_SyntaxError_Warning_Title"), MessageBoxButtons.YesNoCancel, MessageBoxIcon.Warning);

				switch ( result )
				{
					case DialogResult.Yes:
						this.DialogResult = DialogResult.OK;
						this.Close();
						break;
					case DialogResult.No:
						this.DialogResult = DialogResult.Cancel;
						this.Close();
						break;
					case DialogResult.Cancel:						
						break;
				}
			}
			else
			{
				this.DialogResult = DialogResult.OK;
				this.Close();
			}
		}
		#endregion OKButton_Click

		#region CancelButton_Click

		private void CancelButton_Click(object sender, System.EventArgs e)
		{
			DialogResult result = DialogResult.Yes;

            if (this.isDirty)
            {
                // VC 02/03/2010
                // V10.1 UltraMessageBoxManager update
                //result = MessageBox.Show(this, SR.GetString("FormulaBuilderDialog_ConfirmCancel"), SR.GetString("FormulaBuilderDialog_Cancel"), MessageBoxButtons.YesNo, MessageBoxIcon.Question, MessageBoxDefaultButton.Button1);
                result = UltraMessageBoxManager.Show(this, SR.GetString("FormulaBuilderDialog_ConfirmCancel"), SR.GetString("FormulaBuilderDialog_Cancel"), MessageBoxButtons.YesNo, MessageBoxIcon.Question, MessageBoxDefaultButton.Button1);
            }

			if ( result == DialogResult.Yes )
			{
				this.DialogResult = DialogResult.Cancel;
				this.Close();
			}

		}

		#endregion CancelButton_Click		

		#endregion Other Button Events

		#endregion Event Handlers

		#region Private Methods

		#region InitializeUI

		private void InitializeUI()
		{
			this.FunctionNameLabel.Text = string.Empty;
			this.FunctionDescriptionLabel.Text = string.Empty;
			
			//MRS 1/11/05 - Added support for aliasing/cancelling references.
			this.BuildAliasTables();

			FormulaUITypeEditor.PopulateFunctionsTree(this.functionsTree, designInfo, aliasManager);
			FormulaUITypeEditor.PopulateFunctionsMenu((PopupMenuTool)this.ultraToolbarsManager1.Tools["Insert Function"], designInfo, aliasManager);
			FormulaUITypeEditor.PopulateOperandsTree(this.operandsTree, designInfo, formulaProvider, this.aliasManager);
			FormulaUITypeEditor.PopulateOperandsMenu((PopupMenuTool)this.ultraToolbarsManager1.Tools["Insert Operand"], designInfo, formulaProvider, aliasManager);

			this.operandTreeDragHelper = new OperandTreeDragHelper(this.operandsTree);
			this.functionTreeDragHelper = new FunctionTreeDragHelper(this.functionsTree);

			this.formulaRichTextBox.Text = this.formulaProvider.Formula;
			
			this.InitializeDialogStrings();
			this.isDirty = false;

			this.ReStoreTreeSettings();
		}

		#endregion InitializeUI

		#region InitializeDialogStrings

		private void InitializeDialogStrings()
		{
			this.toolTip1.SetToolTip(this.OperatorButtonAdd, SR.GetString("FormulaBuilderDialog_OperandButton_ToolTip_Add") ) ;  //Add");
			this.toolTip1.SetToolTip(this.OperatorButtonSubtract, SR.GetString("FormulaBuilderDialog_OperandButton_ToolTip_Subtract") ) ;  //Subtract");
			this.toolTip1.SetToolTip(this.OperatorButtonMultiply, SR.GetString("FormulaBuilderDialog_OperandButton_ToolTip_Multiply") ) ;  //Multiply");
			this.toolTip1.SetToolTip(this.OperatorButtonDivide, SR.GetString("FormulaBuilderDialog_OperandButton_ToolTip_Divide") ) ;  //Divide");
			this.toolTip1.SetToolTip(this.OperatorButtonExponent, SR.GetString("FormulaBuilderDialog_OperandButton_ToolTip_Exponent") ) ;  //Exponent");
			this.toolTip1.SetToolTip(this.OperatorButtonPercent, SR.GetString("FormulaBuilderDialog_OperandButton_ToolTip_Percent") ) ;  //Percent");
			this.toolTip1.SetToolTip(this.OperatorButtonConcatenate, SR.GetString("FormulaBuilderDialog_OperandButton_ToolTip_Concatenate") ) ;  //Concatenate");
			this.toolTip1.SetToolTip(this.OperatorButtonEquals, SR.GetString("FormulaBuilderDialog_OperandButton_ToolTip_Equals") ) ;  //Equals");
			this.toolTip1.SetToolTip(this.OperatorButtonGreaterThan, SR.GetString("FormulaBuilderDialog_OperandButton_ToolTip_GreaterThan") ) ;  //Greater Than");
			this.toolTip1.SetToolTip(this.OperatorButtonLessThan, SR.GetString("FormulaBuilderDialog_OperandButton_ToolTip_LessThan") ) ;  //Less Than");
			this.toolTip1.SetToolTip(this.OperatorButtonNotEqual, SR.GetString("FormulaBuilderDialog_OperandButton_ToolTip_NotEqualTo") ) ;  //Not Equal to");
			this.toolTip1.SetToolTip(this.OperatorButtonOpenParen, SR.GetString("FormulaBuilderDialog_OperandButton_ToolTip_OpenParentheses") ) ;  //Open Parentheses");
			this.toolTip1.SetToolTip(this.OperatorButtonCloseParen, SR.GetString("FormulaBuilderDialog_OperandButton_ToolTip_CloseParentheses") ) ;  //Close Parentheses");

			this.RedoButton.Text = SR.GetString("FormulaBuilderDialog_Redo");  //"Redo";
			this.UndoButton.Text = SR.GetString("FormulaBuilderDialog_Undo");  //"Undo";
			this.OKButton.Text = SR.GetString("FormulaBuilderDialog_OK");  //"OK";
			this.CancelBtn.Text = SR.GetString("FormulaBuilderDialog_Cancel");  //"Cancel";
			this.ultraTabControl1.Tabs["OperandsTab"].Text = SR.GetString("FormulaBuilderDialog_Tab_Operands");  //"Operands";
			this.ultraTabControl1.Tabs["FunctionsTab"].Text = SR.GetString("FormulaBuilderDialog_Tab_Functions");  //"Functions";
			this.ultraToolbarsManager1.Tools["Cut"].SharedProps.Caption = SR.GetString("FormulaBuilderDialog_Cut");  //"Cu&t";
			this.ultraToolbarsManager1.Tools["Copy"].SharedProps.Caption = SR.GetString("FormulaBuilderDialog_Copy");  //"&Copy";
			this.ultraToolbarsManager1.Tools["Paste"].SharedProps.Caption = SR.GetString("FormulaBuilderDialog_Paste");  //"&Paste";
			this.ultraToolbarsManager1.Tools["Insert Operand"].SharedProps.Caption = SR.GetString("FormulaBuilderDialog_InsertOperand");  //"Insert Operand";
			this.ultraToolbarsManager1.Tools["Insert Function"].SharedProps.Caption = SR.GetString("FormulaBuilderDialog_InsertFunction");  //"Insert Function";
			this.ultraToolbarsManager1.Tools["Undo"].SharedProps.Caption = SR.GetString("FormulaBuilderDialog_Undo");  //"Undo";
			this.ultraToolbarsManager1.Tools["Redo"].SharedProps.Caption = SR.GetString("FormulaBuilderDialog_Redo");  //"Redo";
			this.Text = SR.GetString("FormulaBuilderDialog_Title");  //"Formula Builder";

			this.ultraStatusBar1.Panels["FormulaTarget"].Text = SR.GetString("FormulaBuilderDialog_FormulaTargetLabel", this.formulaProvider.Reference.AbsoluteName);  //"Formula Target: " + this.formulaProvider.Reference.AbsoluteName;

			// AS 4/28/05
			this.ClearButton.Text = SR.GetString("FormulaBuilderDialog_Clear");  //"Clear";

			// MD 11/17/06
			// Dialog Accessibility
			this.AccessibleName = this.Text;
			this.AccessibleDescription = SR.GetString( "FormulaBuilderDialog_AccessibleDescription" );
			this.ultraToolbarsManager1.Tools[ "Cut" ].SharedProps.Caption = SR.GetString( "FormulaBuilderDialog_Cut_AccessibleDescription" );
			this.ultraToolbarsManager1.Tools[ "Copy" ].SharedProps.Caption = SR.GetString( "FormulaBuilderDialog_Copy_AccessibleDescription" );
			this.ultraToolbarsManager1.Tools[ "Paste" ].SharedProps.Caption = SR.GetString( "FormulaBuilderDialog_Paste_AccessibleDescription" );
			this.ultraToolbarsManager1.Tools[ "Insert Operand" ].SharedProps.Caption = SR.GetString( "FormulaBuilderDialog_InsertOperand_AccessibleDescription" );
			this.ultraToolbarsManager1.Tools[ "Insert Function" ].SharedProps.Caption = SR.GetString( "FormulaBuilderDialog_InsertFunction_AccessibleDescription" );
			this.ultraToolbarsManager1.Tools[ "Undo" ].SharedProps.Caption = SR.GetString( "FormulaBuilderDialog_Undo_AccessibleDescription" );
			this.ultraToolbarsManager1.Tools[ "Redo" ].SharedProps.Caption = SR.GetString( "FormulaBuilderDialog_Redo_AccessibleDescription" );
			this.ClearButton.AccessibleName = this.ClearButton.Text;
			this.ClearButton.AccessibleDescription = SR.GetString( "FormulaBuilderDialog_Clear_AccessibleDescription" );
		}

		#endregion InitializeDialogStrings

		#region CompileFormula

		private void CompileFormula ()
		{
			//Compile the formula and display status
			this.compilePending = false;
			string formula = this.Formula;
			if (formula == null ||
				formula.Length == 0 )
			{
                // MRS 5/2/2008 - BR32475
                this.hasSyntaxError = false;

                this.formulaStatusTextBox.Text = SR.GetString("FormulaBuilderDialog_Compile_Message_NoFormula"); // "No Formula";
				return;
			}

            // MRS 11/6/2009 - TFS24422
			//IUltraCalcFormula compiledFormula = this.formulaProvider.CalcManager.CompileFormula(this.formulaProvider.Reference, formula, true);
            IUltraCalcFormula compiledFormula = this.formulaProvider.CalcManager.CompileFormula(compileReference, formula, true);

			this.hasSyntaxError = compiledFormula.HasSyntaxError;
			if ( compiledFormula.HasSyntaxError )
			{
				this.formulaStatusTextBox.Text = compiledFormula.SyntaxError;
				return;
			}

			

			this.formulaStatusTextBox.Text = SR.GetString ("FormulaBuilderDialog_Compile_Message_Success"); // "Formula Compiled Successfully";
		}

		#endregion CompileFormula

		#region InsertFunction

		private void InsertFunction(UltraCalcFunction function)
		{
			if ( function.MaxArgs == 0 )
			{
				this.formulaRichTextBox.SelectedText = string.Format(" {0}() ", function.Name);
				return;
			}

			// MRS 1/21/05
			//FunctionBuilderDialog functionBuilderDialog = new FunctionBuilderDialog(this, function );
            // MRS 11/6/2009 - TFS24422
			//FunctionBuilderDialog functionBuilderDialog = new FunctionBuilderDialog(this, function, this.showHelpLinks );
            FunctionBuilderDialog functionBuilderDialog = new FunctionBuilderDialog(this, function, this.showHelpLinks, this.compileReference);

			DialogResult result = functionBuilderDialog.ShowDialog(this);			
			if (result == DialogResult.OK)
			{
				this.formulaRichTextBox.SelectedText = functionBuilderDialog.Function;
			}
			functionBuilderDialog.Dispose();
		}

		#endregion InsertFunction

		#region GetLastChar
		private char GetLastChar()
		{			
			// AS 10/8/04
			// Since we're going to be using the richtextbox
			// info, we want the unmodified text.
			//
			//string formula = this.Formula;
			string formula = NativeWindowMethods.GetText(this.formulaRichTextBox);
			int index = this.formulaRichTextBox.SelectionStart;
			
			if ( index == 0 ) 
				return char.MinValue;
			
			char lastChar = formula.Substring(this.formulaRichTextBox.SelectionStart - 1, 1).ToCharArray()[0];
			return lastChar;
		}
		#endregion GetLastChar

		#region GetNextChar
		private char GetNextChar()
		{			
			// AS 10/8/04
			// Since we're going to be using the richtextbox
			// info, we want the unmodified text.
			//
			//string formula = this.Formula;
			string formula = NativeWindowMethods.GetText(this.formulaRichTextBox);
			int index = this.formulaRichTextBox.SelectionStart;
			
			if ( index == formula.Length ) 
				return char.MinValue;
			
			char NextChar = formula.Substring(this.formulaRichTextBox.SelectionStart, 1).ToCharArray()[0];
			return NextChar;
		}
		#endregion GetNextChar

		#region GetSelectedFuncDescriptor

		private UltraCalcFunction GetSelectedFunction()
		{
			UltraTree tree = this.functionsTree;
			if ( tree.SelectedNodes.Count == 0 )
				return null;

			UltraTreeNode node = tree.SelectedNodes[0];
			
			return node.Tag as UltraCalcFunction;
		}

		#endregion GetSelectedFuncDescriptor

		#region InsertReferenceNameInfoFormula

		private void InsertReferenceNameIntoFormula(string relativeReferenceName)
		{
			this.formulaRichTextBox.SelectedText = string.Format(" [{0}] ", relativeReferenceName );
			this.formulaRichTextBox.Focus();
		}
		#endregion InsertReferenceNameInfoFormula

		#region Cut, Copy, and Paste

		private void Cut()
		{	
			this.Copy();
			this.formulaRichTextBox.SelectedText = string.Empty;
		}

		private void Copy()
		{	
			if (this.formulaRichTextBox.SelectedText.Length > 0 )
				Clipboard.SetDataObject(this.formulaRichTextBox.SelectedText);
		}

		private void Paste()
		{
			if ( Clipboard.GetDataObject().GetDataPresent(typeof(string)) )
			{
				string pasteText = Clipboard.GetDataObject().GetData(typeof(string)) as string;
				this.formulaRichTextBox.SelectedText = pasteText;
			}
		}

		#endregion Cut, Copy, and Paste

		#region ApplySettingsFromRegistry
			
		private void ApplySettingsFromRegistry( )
		{
			RegistryKey regKey = null;

			try
			{
				regKey = Registry.CurrentUser.CreateSubKey(DESIGNER_REG_KEY);
				if (regKey != null)
				{
					// Dialog location ==================================================================
					int		x	= Convert.ToInt32(regKey.GetValue("DialogX", this.Left));
					int		y	= Convert.ToInt32(regKey.GetValue("DialogY", this.Top));

					// Get the closest screen and make sure that the location is within the screen bounds.
					Point	pt		= new Point(x,y);
					Screen screen	= Screen.FromPoint(pt);
					if (screen.Bounds.Contains(pt))
						this.Location = pt;
					else
						this.Location = new Point(0, 0);


					// Dialog size ======================================================================
					int width		= Convert.ToInt32(regKey.GetValue("DialogWidth", this.Width));
					int height		= Convert.ToInt32(regKey.GetValue("DialogHeight", this.Height));
					this.ClientSize = new Size(width,height);

					// SplitterMain position ============================================================
					x	= Convert.ToInt32(regKey.GetValue("SplitterMainPosition", this.splitterMain.SplitPosition));
					this.splitterMain.SplitPosition = x;


					// SplitterPresets position =========================================================
					x	= Convert.ToInt32(regKey.GetValue("SplitterFunctionsPosition", this.splitterFunctions.SplitPosition));
					this.splitterFunctions.SplitPosition = x;
				}

			}
			finally
			{
				if (regKey != null)
					regKey.Close();
			}
		}
	
		#endregion ApplySettingsFromRegistry

		#region SaveSettingsToRegistry
				
		private void SaveSettingsToRegistry( )
		{
			RegistryKey regKey = null;

			try
			{
				regKey = Registry.CurrentUser.CreateSubKey(DESIGNER_REG_KEY);

				if (regKey != null)
				{
					// Dialog location ==================================================================
					regKey.SetValue("DialogX", this.Location.X);
					regKey.SetValue("DialogY", this.Location.Y);


					// Dialog size ======================================================================
					regKey.SetValue("DialogWidth", this.ClientSize.Width);
					regKey.SetValue("DialogHeight", this.ClientSize.Height);

					// SplitterMain position ============================================================
					regKey.SetValue("SplitterMainPosition", this.splitterMain.SplitPosition);

					// SplitterFunctions position =========================================================
					regKey.SetValue("SplitterFunctionsPosition", this.splitterFunctions.SplitPosition);

				}
			}
			finally
			{
				if (regKey != null)
					regKey.Close();
			}
		}
		
				#endregion SaveSettingsToRegistry

		#region StoreTreeSettings

		private void StoreTreeSettings()
		{
			if ( FormulaUITypeEditor.formulaBuilderFunctionTreeStateManager == null )
				FormulaUITypeEditor.formulaBuilderFunctionTreeStateManager = new TreeStateManager();				

			FormulaUITypeEditor.formulaBuilderFunctionTreeStateManager.Store(this.functionsTree);

			if ( FormulaUITypeEditor.formulaBuilderOperandsTreeStateManager == null )
				FormulaUITypeEditor.formulaBuilderOperandsTreeStateManager = new TreeStateManager();

			FormulaUITypeEditor.formulaBuilderOperandsTreeStateManager.Store(this.operandsTree);
		}

		#endregion StoreTreeSettings

		#region ReStoreTreeSettings

		private void ReStoreTreeSettings()
		{
			if ( FormulaUITypeEditor.formulaBuilderFunctionTreeStateManager != null )
				FormulaUITypeEditor.formulaBuilderFunctionTreeStateManager.ReStore(this.functionsTree);

			if ( FormulaUITypeEditor.formulaBuilderOperandsTreeStateManager != null )
				FormulaUITypeEditor.formulaBuilderOperandsTreeStateManager.ReStore(this.operandsTree);
		}
		
		#endregion ReStoreTreeSettings

		#region VerifyButtonEnabledStates

		private void VerifyButtonEnabledStates()
		{
			this.UndoButton.Enabled = this.formulaRichTextBox.CanUndo;
			this.RedoButton.Enabled = this.formulaRichTextBox.CanRedo;
		}

		#endregion VerifyButtonEnabledStates
		
		//MRS 1/11/05 - Added support for aliasing/cancelling references.
		#region BuildAliasTables

		private void BuildAliasTables()
		{
			this.BuildReferenceAliasTable(null);	
			this.BuildFunctionAliasTable();
		}

		private void BuildReferenceAliasTable(ReferenceNode parentNode)
		{
			ReferenceNode[] refNodes = null;

			if (parentNode == null)
				refNodes = this.aliasManager.refTree;
			else
				refNodes = parentNode.ChildReferences;

			if (refNodes == null || refNodes.Length == 0)
				return;
			
			foreach (ReferenceNode refNode in refNodes)
			{
				object context = null;

				if (refNode.Reference == null)
					context = refNode.DisplayNameResolved;
				else
					context = refNode.Reference.Context;

                // LZ-GSG 03/14/2013 
                //OperandInitializingEventArgs args = new OperandInitializingEventArgs(refNode.DisplayNameResolved, context, this.formulaProvider);
                OperandInitializingEventArgs args = new OperandInitializingEventArgs(refNode.DisplayNameResolved, context, null, this.formulaProvider);
                this.OnOperandInitializing(args);

                // LZ-GSG 03/14/2013
				if (args.Cancel) this.aliasManager.AddExclude(refNode, args);
				this.BuildReferenceAliasTable(refNode);
			}
		}

		private void BuildFunctionAliasTable()
		{
			UltraCalcFunction[] functions = designInfo.GetAllFunctions();
			foreach (UltraCalcFunction function in functions)
			{
				FunctionInitializingEventArgs args = new FunctionInitializingEventArgs(function, this.formulaProvider);
				this.OnFunctionInitializing(args);
				if (args.Cancel)
					this.aliasManager.AddExclude(function);
			}			
		}
		
		#endregion BuildAliasTables

		#endregion Private Methods		

		#region Internal Properties



		#endregion Internal Properties

		//MRS 1/11/05 - Added support for aliasing/cancelling references.
		#region Events

		#region Event objects

		private static readonly object			EventOperandInitializing = new object();
		private static readonly object			EventFunctionInitializing = new object();

		#endregion //Event objects

		#region OnXXX methods

		#region OnOperandInitializing
		/// <summary>
		/// Occurs before the page setup dialog is displayed.
		/// </summary>
		/// <seealso cref="FunctionInitializing"/>
		protected virtual void OnOperandInitializing(OperandInitializingEventArgs e)
		{
			OperandInitializingEventHandler eDelegate = (OperandInitializingEventHandler)Events[FormulaBuilderDialog.EventOperandInitializing];

			if ( eDelegate != null )
				eDelegate( this, e );			
		}
		#endregion //OnOperandInitializing

		#region OnFunctionInitializing
		/// <summary>
		/// Occurs in response to a click on the 'Print' tool after the print operation ends.
		/// </summary>
		/// <seealso cref="OperandInitializing"/>
		protected virtual void OnFunctionInitializing(FunctionInitializingEventArgs e)
		{
			FunctionInitializingEventHandler eDelegate = (FunctionInitializingEventHandler)Events[FormulaBuilderDialog.EventFunctionInitializing];

			if ( eDelegate != null )
				eDelegate( this, e );			
		}
		#endregion //OnFunctionInitializing

		#endregion //OnXXX methods

		#region Event declarations

		#region OperandInitializing

		/// <summary>
		/// Occurs before the page setup dialog is displayed.
		/// </summary>
		/// <seealso cref="FormulaBuilderDialog.OnOperandInitializing"/>
		[LocalizedDescription("LD_FormulaBuilderDialog_E_OperandInitializing")]
		public event OperandInitializingEventHandler OperandInitializing
		{
			add { this.Events.AddHandler( FormulaBuilderDialog.EventOperandInitializing, value ); }
			remove { this.Events.RemoveHandler( FormulaBuilderDialog.EventOperandInitializing, value ); }
		}
		#endregion //OperandInitializing

		#region FunctionInitializing

		/// <summary>
		/// Occurs in response to a click on the 'Print' tool after the print operation ends.
		/// </summary>
		/// <seealso cref="FormulaBuilderDialog.FunctionInitializing"/>
		[LocalizedDescription("LD_FormulaBuilderDialog_E_FunctionInitializing")]
		public event FunctionInitializingEventHandler FunctionInitializing
		{
			add { this.Events.AddHandler( FormulaBuilderDialog.EventFunctionInitializing, value ); }
			remove { this.Events.RemoveHandler( FormulaBuilderDialog.EventFunctionInitializing, value ); }
		}

		#endregion //FunctionInitializing

		#endregion //Event declarations

		#endregion //Events
	}

	
}


#region Copyright (c) 2001-2012 Infragistics, Inc. All Rights Reserved
/* ---------------------------------------------------------------------*
*                           Infragistics, Inc.                          *
*              Copyright (c) 2001-2012 All Rights reserved               *
*                                                                       *
*                                                                       *
* This file and its contents are protected by United States and         *
* International copyright laws.  Unauthorized reproduction and/or       *
* distribution of all or any portion of the code contained herein       *
* is strictly prohibited and will result in severe civil and criminal   *
* penalties.  Any violations of this copyright will be prosecuted       *
* to the fullest extent possible under law.                             *
*                                                                       *
* THE SOURCE CODE CONTAINED HEREIN AND IN RELATED FILES IS PROVIDED     *
* TO THE REGISTERED DEVELOPER FOR THE PURPOSES OF EDUCATION AND         *
* TROUBLESHOOTING. UNDER NO CIRCUMSTANCES MAY ANY PORTION OF THE SOURCE *
* CODE BE DISTRIBUTED, DISCLOSED OR OTHERWISE MADE AVAILABLE TO ANY     *
* THIRD PARTY WITHOUT THE EXPRESS WRITTEN CONSENT OF INFRAGISTICS, INC. *
*                                                                       *
* UNDER NO CIRCUMSTANCES MAY THE SOURCE CODE BE USED IN WHOLE OR IN     *
* PART, AS THE BASIS FOR CREATING A PRODUCT THAT PROVIDES THE SAME, OR  *
* SUBSTANTIALLY THE SAME, FUNCTIONALITY AS ANY INFRAGISTICS PRODUCT.    *
*                                                                       *
* THE REGISTERED DEVELOPER ACKNOWLEDGES THAT THIS SOURCE CODE           *
* CONTAINS VALUABLE AND PROPRIETARY TRADE SECRETS OF INFRAGISTICS,      *
* INC.  THE REGISTERED DEVELOPER AGREES TO EXPEND EVERY EFFORT TO       *
* INSURE ITS CONFIDENTIALITY.                                           *
*                                                                       *
* THE END USER LICENSE AGREEMENT (EULA) ACCOMPANYING THE PRODUCT        *
* PERMITS THE REGISTERED DEVELOPER TO REDISTRIBUTE THE PRODUCT IN       *
* EXECUTABLE FORM ONLY IN SUPPORT OF APPLICATIONS WRITTEN USING         *
* THE PRODUCT.  IT DOES NOT PROVIDE ANY RIGHTS REGARDING THE            *
* SOURCE CODE CONTAINED HEREIN.                                         *
*                                                                       *
* THIS COPYRIGHT NOTICE MAY NOT BE REMOVED FROM THIS FILE.              *
* --------------------------------------------------------------------- *
*/
#endregion Copyright (c) 2001-2012 Infragistics, Inc. All Rights Reserved