﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Infragistics.Win.UltraWinCalcManager.FormulaBuilder;
using Infragistics.Win.CalcEngine;
using System.Reflection;

namespace UltraGirdSummaryGroupBy
{
    class AliasFormulaBuilderDialog:FormulaBuilderDialog
    {
        public Dictionary<string, string> AliasLookup = new Dictionary<string, string>();
            
            public AliasFormulaBuilderDialog(IFormulaProvider formulaProvider):base(formulaProvider)
        {
            this.Load += new EventHandler(AliasFormulaBuilderDialog_Load);
        }

        void AliasFormulaBuilderDialog_Load(object sender, EventArgs e)
        {
            FormulaBuilderDialog formulaBuilderDialog = sender as FormulaBuilderDialog;
            Type formulaBuilderDialogType = typeof(FormulaBuilderDialog);
            FieldInfo aliasManagerField = formulaBuilderDialogType.GetField("aliasManager",
                                                                      BindingFlags.Instance | BindingFlags.NonPublic |
                                                                      BindingFlags.GetField);
            var aliasManager = aliasManagerField.GetValue(sender);
            Type aliasManagerType = aliasManager.GetType();
            FieldInfo refTreeField = aliasManagerType.GetField("refTree",
                                                               BindingFlags.GetField | BindingFlags.Instance |
                                                               BindingFlags.NonPublic);
            ReferenceNode[] refTree = (ReferenceNode[])refTreeField.GetValue(aliasManager);
            ReferenceNode controls = refTree[0];

            // While the following sets the display text for the controls the operandsTree has already 
            // been populated and that is why we later call populateOperandsTree with reflection.
            SetDisplayText(controls);

            FieldInfo operandsTreeField = formulaBuilderDialogType.GetField("operandsTree",
                                                                            BindingFlags.NonPublic |
                                                                            BindingFlags.Instance |
                                                                            BindingFlags.GetField);
            var operandsTree = operandsTreeField.GetValue(formulaBuilderDialog);

            FieldInfo designInfoField = formulaBuilderDialogType.GetField("designInfo",
                                                                          BindingFlags.NonPublic | BindingFlags.Instance |
                                                                          BindingFlags.GetField);
            var designInfo = designInfoField.GetValue(formulaBuilderDialog);

            FieldInfo formulaProviderField = formulaBuilderDialogType.GetField("formulaProvider",
                                                                               BindingFlags.NonPublic |
                                                                               BindingFlags.Instance |
                                                                               BindingFlags.GetField);
            var formulaProvider = formulaProviderField.GetValue(formulaBuilderDialog);

            Type formulaUITypedEditorType = typeof(FormulaUITypeEditor);
            MethodInfo populateOperandsTreeMethod = formulaUITypedEditorType.GetMethod("PopulateOperandsTree",
                                                                                        BindingFlags.NonPublic | BindingFlags.Static);


            populateOperandsTreeMethod.Invoke(null,
                                               new object[] { operandsTree, designInfo, formulaProvider, aliasManager });
        }

        private void SetDisplayText(ReferenceNode controls)
        {
            string displayNameResolved = controls.DisplayNameResolved;
            if (AliasLookup.ContainsKey(displayNameResolved))
            {
                controls.DisplayName = AliasLookup[displayNameResolved];
            }
            if (controls.ChildReferences != null)
            {
                foreach (ReferenceNode node in controls.ChildReferences)
                {
                    SetDisplayText(node);
                }
            }
        }
    }
}
